/*

 Gestione GUI 
 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/

#include "sudoky.h"

CmdInfo *timer;
Timer *timer_s;
char ctimer[30];

void debug ()
{
	int y,x;
	//
	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			if (IsCandi (y,x))
				printf ("c");
			if (!IsFixed (y,x))
				printf ("u");
			printf ("%s ",GetCandidati(y,x));
		}
		printf ("\n");
	}
	printf ("\n");

}
char *celldisplay (int y,int x)
{
	//
	// Copia la Cella nel Display
	//
	int pos=(y*(SUD_TAB*(SUD_TAB+1)))+(x*(SUD_TAB+1));

	if (IsCandi (y,x) && HIDDENCANDI)
		strcpy (LABELBUF+pos," ");
	else
		strcpy (LABELBUF+pos,GetCandidati(y,x));
	return (LABELBUF+pos);
}

int Redisplay (int Mode)
{
	//
	// Ricarica Display
	//
	int y,x;
	CmdInfo *cella;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			sprintf (BUFF,"%d%d",y,x);
			cella=CercaNomeComando (BUFF);
			if (IsCandi (y,x))
			{
				xSetCmdFont (cella,SMALLFONT);
				cella->Fg=CANDI_COLOR;
			}
			else
			{
				xSetCmdFont (cella,BIGFONT);
				cella->Fg=IsFixed (y,x) ? FIXED_COLOR : CANDI_COLOR;
			}
			if (SUD_BUF[y][x] & (1<<(EVIDENCE-1)))
				cella->Bg=EVIDENCE_BG;
			else
				cella->Bg=GetColor(BUTTONBG);

			celldisplay (y,x);
		}
	}
	PrintFlush(NULL);
	if (Mode==0) SudoFinish (0);
	return (0);
}

int ResetGame ()
{
	//
	// Reset
	//
	int x,y;
	VUOTI=(SUD_TAB * SUD_TAB);

	memset((char *) LABELBUF, 0x20, sizeof(LABELBUF));

	for (y=0;y<SUD_TAB;y++)
		for (x=0;x<SUD_TAB;x++)	
			SUD_BUF[y][x]=0x00; //0x5FF;

	return (0);
}

int SudoFinish (int Save)
{
	int ret=0;

	
	AddItemListCmd (ViewComment, LABEL,"-- Break --",NULL);

	ApreFont ("6x10");
	xListBoxRefresh (ViewComment);
	ApreFont ("9x15");

	sprintf (vuoti,"%2d ",VUOTI);
	CambiaTesto(label_vuoti,vuoti);
	
	CheckAll();

	if (Save && (ViewComment->NumeroItem>2))
		DoSaved();

	if (VUOTI==0)
	{
		TimerStop(timer_s);
		Alert (
			gettext("Game Resolved"),
			gettext("Ok"),NULL);
		SudokuNuovo ();
		ret=0;
	}

	return (ret);
}

void Clear_Comments ()
{
	//
	// Cancella Commenti
	//
	xClearAllListBoxItem (ViewComment);
}

int RemoveCandidatoGUI(int y,int x,int candidato,int step)
{
	CmdInfo *cella;
	int riga,colonna,blocco,pos,r,c;
	int save;

	if (!SOLVE) return (0);

	// Esce se NON e' candidato
	if (!IsCandi (y,x)) 
		return (0);

	// Esce se candidato unico
	if (IsOnly1Candi(SUD_BUF[y][x]))
		return (0);

	// Esce se NON rimosso
	save=SUD_BUF[y][x];
	RemoveCandidato (&SUD_BUF[y][x], candidato);
	if (save==SUD_BUF[y][x]) 
		return (0);

	// Rintraccia la cella
	sprintf(BUFF,"%d%d",y,x);
	cella=CercaNomeComando (BUFF);

	// EVIDENCE
	if (candidato==EVIDENCE && cella->Bg!=GetColor(BUTTONBG))
		cella->Bg=GetColor(BUTTONBG);

	// Display cella
	celldisplay(y,x);
	PrintFlush (cella);

	// Se + di 1 candidato rimanente esce
	if (ContaBits(SUD_BUF[y][x])>1)
		return (0);

	if (step==0) step=1;

	if (step==1)
	{
		candidato=atoi(GetCandidati(y,x));
		for (colonna=0;colonna<SUD_TAB;colonna++)
		{
			RemoveCandidatoGUI(y,colonna,candidato,1);
		}
		step=2;
	}
	if (step==2)
	{
		candidato=atoi(GetCandidati(y,x));
		for (riga=0;riga<SUD_TAB;riga++)
		{
			RemoveCandidatoGUI(riga,x,candidato,2);
		}
		step=3;
	}
	if (step==3)
	{
		candidato=atoi(GetCandidati(y,x));
		Coordinateyx2Blocco (y,x,&blocco,&pos);
		for (pos=0;pos<SUD_TAB;pos++)
		{
			//
			CoordinateBlocco2yx (blocco,pos, &r, &c);
			RemoveCandidatoGUI(r,c,candidato,3);
		}
		step=3;
	}
	
	return (0);

}

int InsertNumeroGUI(int y,int x,int candidato,int step)
{
	CmdInfo *cella;
	int riga,colonna,blocco,pos,r,c;

	if (!SOLVE) return (0);

	SUD_BUF[y][x]=0x0;
	AddCandidato (&SUD_BUF[y][x], candidato);
	UnsetFlagCandidato (&SUD_BUF[y][x], CANDI_MSK);

	sprintf(BUFF,"%d%d",y,x);
	cella=CercaNomeComando (BUFF);
	
	xSetCmdFont (cella,BIGFONT);
	cella->Fg=CANDI_COLOR;
	// EVIDENCE
	if (candidato!=EVIDENCE && cella->Bg!=GetColor(BUTTONBG))
		cella->Bg=GetColor(BUTTONBG);

	VUOTI--;

	celldisplay(y,x);
	PrintFlush (cella);

	if (step==0) step=1;

	if (step==1)
	{
		candidato=atoi(GetCandidati(y,x));
		for (colonna=0;colonna<SUD_TAB;colonna++)
		{
			RemoveCandidatoGUI(y,colonna,candidato,1);
		}
		step=2;
	}
	if (step==2)
	{
		candidato=atoi(GetCandidati(y,x));
		for (riga=0;riga<SUD_TAB;riga++)
		{
			RemoveCandidatoGUI(riga,x,candidato,2);
		}
		step=3;
	}
	if (step==3)
	{
		candidato=atoi(GetCandidati(y,x));
		Coordinateyx2Blocco (y,x,&blocco,&pos);
		for (pos=0;pos<SUD_TAB;pos++)
		{
			//
			CoordinateBlocco2yx (blocco,pos, &r, &c);
			RemoveCandidatoGUI(r,c,candidato,3);
		}
		step=3;
	}

	return (0);
}

int SudoNotify (CmdInfo *comando)
{
	printf ("comando %p\n",comando);
	return (0);
}

int AskRealCandi (int oy,int ox)
{
	//
	// Called from SudoBtPress1 
	// 4 nonfixed number 
	//
	int x,y,b,p;
	int candi;
	int new=0;	// bitmask
	int found=0;

	Coordinateyx2Blocco (oy,ox,&b,&p);

	for (candi=0;candi<SUD_TAB;candi++)
	{
		for (x=0;!found && x<SUD_TAB;x++)
		{
			if (IsOnly1Candi (SUD_BUF[oy][x]) && 
				CandiExist (SUD_BUF[oy][x],candi+1))
			{
				AddCandidato (&new,candi+1);
				found=1;
				break;
			}
		}
		for (y=0;!found && y<SUD_TAB;y++)
		{
			if (IsOnly1Candi (SUD_BUF[y][ox]) && 
				CandiExist (SUD_BUF[y][ox],candi+1))
			{
				AddCandidato (&new,candi+1);
				found=1;
				break;
			}
		}
		for (p=0;!found && p<SUD_TAB;p++)
		{
			CoordinateBlocco2yx (b,p,&y,&x);
			if (IsOnly1Candi (SUD_BUF[y][x]) && 
				CandiExist (SUD_BUF[y][x],candi+1))
			{
				AddCandidato (&new,candi+1);
				found=1;
				break;
			}
		}
		found=0;
	}
	
	new^=0x1ff;		// Inverte gli ultimi 9 bits
	new|=SUD_BUF[oy][ox];   // Setta anche il vecchio candidato

	return (new); 
}

int SudoBtPress1(CmdInfo *cella)
{
	//
	// Inserimento Manuale Numero
	//
	char candidati_old[SUD_TAB+1];
	int y,x,c;
	int solve_old;
	int replace=0;

	y=cella->Name[0]-'0';
	x=cella->Name[1]-'0';
	
	strcpy (candidati_old,GetCandidati(y,x));

	if (IsFixed (y,x))
	{
		Alert (
			gettext("This number is fixed!"),
			gettext("Ok"),NULL);
		return (0);

	}
	if (!IsCandi (y,x))
	{
		// TODO APP to work
		strcpy (candidati_old,GetCandidati2(AskRealCandi (y,x)));
		replace=1;
		//return (0);
	}
	sprintf (BUFF,
		gettext("Cell R%dC%d [%s]\n \nNumber to insert? "),
		y+1,x+1,candidati_old);

	c=Alert (BUFF,"1","2","3","4","5","6","7","8","9",NULL);
	if (c==-1) return (0);

	if (strcmp(candidati_old,""))
	{ 
		if (strchr(candidati_old, c+'0')==0)
		{
			sprintf (BUFF,
				gettext("Warning!!!\n The Number [%d] in R%dC%d is not correct"),
				c,y+1,x+1);

			Alert (BUFF,
				gettext("Ok"),NULL);
			return (0);
		}
	}
	
	solve_old=SOLVE;SOLVE=1;
	if (replace) VUOTI++;
	InsertNumeroGUI(y,x,c,0);
	SOLVE=solve_old;

	Clear_Comments ();
	AddItemListCmd (ViewComment, LABEL,
		gettext("MANUAL INSERT"),NULL);
	sprintf (BUFF,
		gettext("  Set [%d] in R%dC%d"),c,y+1,x+1);
	AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);
	SudoFinish(1);
	
	return (0);
}

int SudoBtPressR()
{
	//
	// Eliminazione Manuale Candidato
	//
	CmdInfo *cella=UltimoComandoSelezionato(0,NULL);
	char candidati_old[SUD_TAB+1];
	int y,x,c;
	int solve_old;
	
	y=cella->Name[0]-'0';
	x=cella->Name[1]-'0';

	strcpy (candidati_old,GetCandidati(y,x));
	if (!IsCandi (y,x))
	{
		Alert (
			gettext("There are not candidates to remove"),
			gettext("Ok"),NULL);
		return (0);
	}
	if (IsOnly1Candi(SUD_BUF[y][x]))
	{
		Alert (
			gettext("Cannot remove single candidate"),
			gettext("Ok"),NULL);
		return (0);
	}
	sprintf (BUFF,
		gettext("Cell R%dC%d [%s]\n \nCandidate to remove?"),
		y+1,x+1,candidati_old);

	c=Alert (BUFF,"1","2","3","4","5","6","7","8","9",NULL);
	if (c==-1) return (0);

	if (strchr(candidati_old, c+'0')==0)
	{
		sprintf (BUFF,
			gettext("Warning!!!\n The canditate [%d] in R%dC%d not exist"),
			c,y+1,x+1);

		Alert (BUFF,
			gettext("Ok"),NULL);
		return (0);
	}

	solve_old=SOLVE;SOLVE=1;
	RemoveCandidatoGUI(y,x,c,0);
	SOLVE=solve_old;

	Clear_Comments ();
	AddItemListCmd (ViewComment, LABEL,
		gettext("MANUAL REMOVE CANDIDATE"),NULL);
	sprintf (BUFF,
		gettext("  Unset [%d] in R%dC%d -> [%s]"),
		c,y+1,x+1,GetCandidati(y,x));
	AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);
	SudoFinish(1);

	return (0);
}

void sudo_start ()
{
	//
	// Mostra il Gioco 
	//
	CmdInfo *cmd;
	int y,x,posy,posx;
	int dimsquare=50;
	int dimgap=3;
	int bordo=3;

	posx=5+dimsquare+dimgap+bordo;posy=4;
	for (x=0;x<SUD_TAB;x++)
	{
		if (x && ((x % DIVX)==0)) 
			posx=posx+dimgap;

		sprintf (LABELCOLONNA[x],"C%d",x+1);

		cmd=ApreBottone(area_sudo,
			posx,
			posy,
			dimsquare,dimsquare,
			LABELCOLONNA[x],NULL);

		cmd->Tipo=AREA;
		cmd->Attivo=0;

		posx=posx+dimsquare+bordo;
	}
	posx=5;posy=(posy+dimsquare)+dimgap+bordo;
	for (y=0;y<SUD_TAB;y++)
	{
		if (y && ((y % DIVY)==0)) 
			posy=posy+dimgap;

		posx=5;
		sprintf (LABELRIGA[y],"R%d",y+1);
		cmd=ApreBottone(area_sudo,
			posx,
			posy,
			dimsquare,dimsquare,
			LABELRIGA[y],NULL);

		cmd->Tipo=AREA;
		cmd->Attivo=0;

		posx=posx+dimsquare+dimgap+bordo; 
		for (x=0;x<SUD_TAB;x++)
		{
			if (x && ((x % DIVX)==0)) 
				posx=posx+dimgap;

			cmd=ApreBottone(area_sudo,
				posx,
				posy,
				dimsquare,dimsquare,
				celldisplay (y,x),
				SudoBtPress1);

			// Assegna il Bottone Dx
			SetSignalCallBack (cmd,Button3Release,SudoBtPressR,NULL);
			
			
			sprintf (LABELCELL+(y*SUD_TAB*5)+(x*5),"%d%d",y,x);
			AddNomeComando (cmd,LABELCELL+(y*SUD_TAB*5)+(x*5));

			if (IsCandi (y,x))
			{
				xSetCmdFont (cmd,SMALLFONT);
				cmd->Fg=CANDI_COLOR;
			}
			else
			{
				xSetCmdFont (cmd,BIGFONT);
				cmd->Fg=IsFixed (y,x) ? FIXED_COLOR : CANDI_COLOR;
			}

			posx=posx+dimsquare+bordo;
		}
		posy=posy+dimsquare+bordo;
	}
}


int SudokyHiddenCandi ()
{
	//
	// Swap to Hidden/Show Candi
	//
	static char *Label1=" Hide Candi ";
	static char *Label2=" Show Candi ";
	int y,x,pos;
	
	HIDDENCANDI=!HIDDENCANDI;
	
	if (HIDDENCANDI)
	{
		CmdHideShow->Label=Label2;
		for (y=0;y<SUD_TAB;y++)
		{
			for (x=0;x<SUD_TAB;x++)	
			{
				if (IsCandi (y,x))
				{
					pos=(y*(SUD_TAB*(SUD_TAB+1)))+(x*(SUD_TAB+1));
					memset((char *) LABELBUF+pos, 0x0, SUD_TAB);
				}
			}
		}
	}
	if (!HIDDENCANDI)
	{
		CmdHideShow->Label=Label1;
		for (y=0;y<SUD_TAB;y++)
		{
			for (x=0;x<SUD_TAB;x++)	
			{
				if (IsCandi (y,x))
				{
					pos=(y*(SUD_TAB*(SUD_TAB+1)))+(x*(SUD_TAB+1));
					strcpy (LABELBUF+pos,GetCandidati(y,x));
				}
			}
		}

	}
	//
	PrintFlush (NULL);

	return (0);
}

int SudokyDeduceSolve (CmdInfo *Cmd)
{

	if (!Cmd->BUpDn) return 0;

	SOLVE=!SOLVE;
	
	if (Cmd==CmdSolve)
	{
		CmdDeduce->BUpDn=!CmdDeduce->BUpDn;
		CmdDeduce->Bg=GetColor(BUTTONBG);
		PrintFlush (CmdDeduce);
	}
	else
	{
		CmdSolve->BUpDn=!CmdSolve->BUpDn;
		CmdSolve->Bg=GetColor(BUTTONBG);
		PrintFlush (CmdSolve);
	}

	Cmd->BUpDn=!Cmd->BUpDn;
	Cmd->Bg=LightColor(Cmd->Bg);
	PrintFlush (Cmd);

	return (0);
}

int ReadReadMe ()
{
	char *fname="README";
	char *lang;
	char freadme[64];

	strcpy (freadme,fname);
	lang=getenv("LANG");
	if (lang) 
	{
		lang[2]='\0';
		sprintf (freadme,"%s/%s/LC_MESSAGES/%s",DIR_PO,lang,fname);
	}
	else
		sprintf (freadme,"%s/%s/LC_MESSAGES/%s",DIR_PO,"en",fname);

	printf ("%s\n",freadme);
	xViewFile (freadme,fname,430,400);

	return (0);
}

void SudoSymmetry ()
{
	int Type=IsSymmetric ();
	//
	if (Type==0x00)
	{
		sprintf (BUFF,gettext("Warning!!! The puzzle has not Symmetry")); 
		AddItemListCmd (ViewComment, LABEL, BUFF,NULL);

	}
	if (Type==0x3F)
	{
		sprintf (BUFF,gettext("The puzzle has a full dihedral symmetry.")); 
		AddItemListCmd (ViewComment, LABEL, BUFF,NULL);
		Type=0;
	}
	if (Type&32)
	{
		sprintf (BUFF,gettext("The puzzle has a Full rotational symmetry")); 
		AddItemListCmd (ViewComment, LABEL, BUFF,NULL);
		Type=0;
	}
	if (Type&16)
	{
		sprintf (BUFF,gettext("The puzzle has a Horizzontal and Vertical reflection symmetry")); 
		AddItemListCmd (ViewComment, LABEL, BUFF,NULL);
		Type=0;
	}
	if (Type&8)
	{
		sprintf (BUFF,gettext("The puzzle has a Diagonal and anti-diagonal reflection symmetry")); 
		AddItemListCmd (ViewComment, LABEL, BUFF,NULL);
		Type=0;
	}
	if (Type&4)
	{
		sprintf (BUFF,gettext("The puzzle has 180%c rotational symmetry"),176); 
		AddItemListCmd (ViewComment, LABEL, BUFF,NULL);
		Type=0;
	}
	if (Type&2)
	{
		sprintf (BUFF,gettext("The puzzle has Horizzontal or Vertical reflection")); 
		AddItemListCmd (ViewComment, LABEL, BUFF,NULL);
		Type=0;
	}
	if (Type&1)
	{
		sprintf (BUFF,gettext("The puzzle has Diagonal or anti-diagonal reflection")); 
		AddItemListCmd (ViewComment, LABEL, BUFF,NULL);
		Type=0;
	}

}

int SudokuNuovo ()
{
	//
	// Nuovo Giovo
	//
	int RandomFile ();
	static int firsttime=1;
	int RND=1;

	if (!firsttime)
	{
	/*
		if (Alert (
			gettext("Do you want to begin a new game?"),
			gettext("Yes"),gettext("No"),NULL)!=1)
			return (0);
	*/
		if (Alert (
			gettext("Do you want to begin a new game?"),
			gettext("No"),gettext("Yes"),NULL)!=2)
			return (0);
	}

	strcpy (FILENAME," ");
	VUOTI=SUD_TAB*SUD_TAB;
	CORSAVED=0;MAXSAVED=0;
	ResetGame ();

	if (firsttime)
	{
		ViewComment=AddListCmd ("Sudo",NULL);
		SetSignalCallBack (ViewComment,EnterNotify,SudoListBoxCallBack,NULL);
		SetSignalCallBack (ViewComment,LeaveNotify,SudoListBoxCallBack,NULL);


		//ReadReadMe ();
		if (RND) RandomFile();
		ApreFont ("6x10");
		xListBox (area_table,ViewComment,565, 60, 285, 150);
		ApreFont ("9x15");

		sudo_start ();
	}
	else
	{

		Clear_Comments ();

		if (RND) RandomFile();
		Redisplay(0);
	}
	//
	DoSaved ();
	//
	CambiaTesto(label_filename,FILENAME);
	//
	sprintf (vuoti,"%2d ",VUOTI);
	CambiaTesto(label_vuoti,vuoti);
	//
	TimerStart (timer_s);

	firsttime=0;

	return (0);
}

int SudokyApri ()
{
	char *CurFile=NULL;

	CurFile=xFiles(DIR_GAMES,NULL);
	printf ("Loading %s\n",CurFile);
	if (CurFile==NULL) return (0);
	
	extract_filename (CurFile,FILENAME);

	// 
	Clear_Comments ();
	//
	CORSAVED=0;MAXSAVED=0;
	ResetGame();
	//
	sprintf (BUFF,"Loading %s",FILENAME);
	AddItemListCmd (ViewComment, LABEL, BUFF,NULL);
	//
	CaricaGame (CurFile);
	SudoSymmetry ();
	// 
	RemoveCandidati ();
	// 
	CambiaTesto(label_filename,FILENAME);
	// 
	sprintf (vuoti,"%2d ",VUOTI);
	CambiaTesto(label_vuoti,vuoti);
	//
	DoSaved ();

	Redisplay(0);

	TimerStart (timer_s);

	return (0);
}

int getrand (int toprange)
{
	//
	// Funzione Random
	//
	//
	static int f=0;
	if (!f)
	{
		srand (time (NULL));
		f=!f;
	}
	return (rand()/(int)(((unsigned)RAND_MAX + 1) / toprange));
}

int RandomFile ()
{
	struct dirent **files;
	int TotaleFiles,x;
	char CurFile[128];

	int sud_file_select();

	TotaleFiles=scandir(DIR_GAMES,&files,sud_file_select,alphasort);
	if (TotaleFiles==-1)
	{
		printf ("File(s) not found in %s\nPlease type 'make install' as root\n",DIR_GAMES);
		exit (1);
	}

	sprintf (CurFile,"%s/%s",DIR_GAMES,files[(getrand (TotaleFiles))]->d_name);

	for (x=0;x<TotaleFiles;x++) free(files[x]);
	free (files);

	extract_filename (CurFile,FILENAME);
	//
	printf ("Loading %s\n",CurFile);

	sprintf (BUFF,"Loading %s",FILENAME);
	AddItemListCmd (ViewComment, LABEL, BUFF,NULL);
	//
	CaricaGame (CurFile);
	SudoSymmetry ();
	// 
	RemoveCandidati ();
	// 
	return (0);
}

int sud_file_select(struct direct *entry)
{
	// 
	// Nota che questa funzione deve stare dopo la 
	// chiamata di scandir altrimenti genera un warning
	//
	char buff[64];
	struct stat stat_buf;

	sprintf (buff,"%s/%s",DIR_GAMES,entry->d_name);
	stat (buff,&stat_buf);
	if((stat_buf.st_mode & S_IFMT) == S_IFDIR)
		return (0);
	
	return (1);
}


int SudokyEnd ()
{
	int result;
	result=Alert (
		gettext("Do you want to exit?"),
		gettext("Yes"),
		gettext("No"),NULL);
	//
	result=(result==1) ? 1 : 0;

	return (result);
}

int SudoLicense()
{
	char *License=_DIR_DAT "LICENSE";


	xViewFile (License,"License",770,400);
	return (0);
}

int SudoHelp()
{
	char *lang;
	char fmethods[64];

	strcpy (fmethods,"METHODS");
	lang=getenv("LANG");
	if (lang) 
	{
		lang[2]='\0';
		sprintf (fmethods,"%s/%s/LC_MESSAGES/METHODS",DIR_PO,lang);
	}
	else
		sprintf (fmethods,"%s/%s/LC_MESSAGES/METHODS",DIR_PO,"en");

	xViewFile (FullPath(fmethods),NULL,550,400);
	return (0);
}

int SudoInfo()
{
	Alert (
		gettext("XSudoky 1.0.2\n \nWritten by Max Cavallo 2007\n \nixamit@gmail.com\n "),
		gettext("Ok"),NULL);
	return (0);
}

int SudoImpostaColore()
{
	static int colore=1;

	if (colore)
	{
		EVIDENCE_BG=VERDE_OLIVA_SCURO;
		SetColor (WINFG,GIALLO); SetColor(WINBG,DarkColor(VERDE));
		SetColor (BUTTONFG,GIALLO); SetColor (BUTTONBG,DarkColor(VERDE));
		SetColor (INPUTFG,GIALLO); SetColor (INPUTBG,DarkColor(VERDE));	
		SetColor (MENUFG,GIALLO); SetColor (MENUBG,DarkColor(VERDE));
		SetColor (LISTBOXFG,GIALLO); SetColor (LISTBOXBG,DarkColor(VERDE));
	}
	else
	{
		EVIDENCE_BG=BLU_ACCIAIO;
		SetColor (WINFG,GIALLO); SetColor(WINBG,DarkColor(AZZURRO));
		SetColor (BUTTONFG,GIALLO); SetColor (BUTTONBG,DarkColor(AZZURRO));
		SetColor (INPUTFG,GIALLO); SetColor (INPUTBG,DarkColor(AZZURRO));	
		SetColor (MENUFG,GIALLO); SetColor (MENUBG,DarkColor(AZZURRO));
		SetColor (LISTBOXFG,GIALLO); SetColor (LISTBOXBG,DarkColor(AZZURRO));
	}

	ChangeColor (NULL);
	//
	colore=!colore;
	Redisplay (0); //TODO 1 sparisce la barra ListBox
	return (0);

}

int SudoShowTime()
{
	struct timeval tv;
	time_t curtime;
	//
	tv=TimerWatch (timer_s);
	curtime=tv.tv_sec;

	strftime(ctimer,30,"%T",gmtime(&curtime));
	XClearWindow(GetDisplay(), timer->win);
	PrintFlush(timer);

	return (0);
}



int main (int argc, char **argv)
{
	
	CmdInfo *c;
	InitFinestre (argc, argv);

	if (GetDepth ()< 24)
	{
		sprintf (BUFF,"Warning!!!\nYou must have 24-bit color! You have %d-bit now!",GetDepth ());
		Alert (BUFF,"Ok",NULL);
	}
	


#define LOCALEDIR DIR_PO

	setlocale (LC_ALL, "");
	bindtextdomain (PACKAGE, LOCALEDIR);
	textdomain (PACKAGE);


	EVIDENCE_BG=BLU_ACCIAIO;
	

	SetClientMessage(SudokyEnd);

	// Varia Colori B&W
	/*
	SetColor (WINFG,NERO); SetColor(WINBG,GRIGIO15);
	SetColor (BUTTONFG,NERO); SetColor (BUTTONBG,GRIGIO20);
	SetColor (INPUTFG,NERO); SetColor (INPUTBG,GRIGIO20);
	SetColor (MENUFG,NERO); SetColor (MENUBG,GRIGIO20);
	SetColor (LISTBOXFG,NERO); SetColor (LISTBOXBG,GRIGIO15);
*/
	SetColor (WINFG,BIANCO);
	SetColor (BUTTONFG,BIANCO);
	// Finestre
	mio=ApreFinestraCentrale ("xSudoky", 900, 595);
	area_table=ApreArea (mio,20,20,860,555,GetColor(WINBG),GetColor(WINFG),2);
	area_sudo =ApreArea (area_table,5,5,545,545,BLU_NOTTE,GetColor(WINFG),2);
	area_shortinfo=ApreArea (area_table,565,5,285,50,GetColor(WINBG),GetColor(WINFG),2);
	area_shortinfo->BUpDn=0;
	area_cmd  =ApreArea (area_table,565,225,285,320,GetColor(WINBG),GetColor(WINFG),2);
	area_cmd->BUpDn=0;
	area_subcmd =ApreArea
	(area_cmd,0,85,285,205,GetColor(WINBG),GetColor(WINFG),2);

	// Menu
	AddMenu (gettext(" File "));
	AddItemMenu (gettext(" New       "),SudokuNuovo);
	AddItemMenu (gettext(" Open...   "),SudokyApri);
	AddItemMenu (gettext(" Print...  "),SudokyStampa);
	AddItemMenu (gettext(" Exit      "),SudokyEnd);
	//
	AddMenu (gettext(" Settings "));
	AddItemMenu (gettext(" Change Colors "),SudoImpostaColore);
	//
	AddMenu (gettext(" Help  "));
	AddItemMenu (gettext(" How To Play "),ReadReadMe);
	AddItemMenu (gettext(" Info XSudoky "),SudoInfo);
	AddItemMenu (gettext(" License"),SudoLicense);
	//
	// 
	//
	strcpy (FILENAME," ");
	label_filename=Print(area_shortinfo,1,0,FILENAME);
	//
	//
	//
	sprintf (vuoti,"%2d ",VUOTI);
	Print (area_shortinfo,1,2,gettext("Empty="));
	label_vuoti=Print(area_shortinfo,7,2,vuoti);
	//
	// Set Timer
	//
	Print (area_shortinfo,17,2,gettext("Timer="));
	strcpy(ctimer,"00:00:00");
	timer=Print (area_shortinfo,23,2,ctimer);
	timer_s=SetTimerCallBack(SudoShowTime,NULL,1000000);

	//SudokuNuovo();
	
	// ------------- Bottoni sx
	#ifdef START_WITH_CANDI
		CmdHideShow=ApreBottone(area_cmd,25,5,100,20," Hide Candi ",SudokyHiddenCandi);
		HIDDENCANDI=0;
	#else
		CmdHideShow=ApreBottone(area_cmd,25,5,100,20," Show Candi ",SudokyHiddenCandi);
		HIDDENCANDI=1;
	#endif


	EVIDENCE=0;
	ApreBottone(area_cmd, 25, 30,15,20,"0",SudoEvidence);
	ApreBottone(area_cmd, 46, 30,15,20,"1",SudoEvidence);
	ApreBottone(area_cmd, 67, 30,15,20,"2",SudoEvidence);
	ApreBottone(area_cmd, 88, 30,15,20,"3",SudoEvidence);
	ApreBottone(area_cmd,109, 30,15,20,"4",SudoEvidence);
	ApreBottone(area_cmd, 25, 55,15,20,"5",SudoEvidence);
	ApreBottone(area_cmd, 46, 55,15,20,"6",SudoEvidence);
	ApreBottone(area_cmd, 67, 55,15,20,"7",SudoEvidence);
	ApreBottone(area_cmd, 88, 55,15,20,"8",SudoEvidence);
	ApreBottone(area_cmd,109, 55,15,20,"9",SudoEvidence);

	CmdDeduce=ApreBottone(
		area_cmd, 155, 5,100,20,gettext("Deduce"),SudokyDeduceSolve); 
	CmdSolve=ApreBottone(
		area_cmd, 155,30,100,20,gettext("Solve "),SudokyDeduceSolve);

	#ifdef START_WITH_SOLVE
		CmdSolve->BUpDn=!CmdSolve->BUpDn;
		CmdSolve->Bg=LightColor(CmdSolve->Bg);	
 		SOLVE=1;
	#else
		CmdDeduce->BUpDn=!CmdDeduce->BUpDn;
		CmdDeduce->Bg=LightColor(CmdDeduce->Bg);
		SOLVE=0;
	#endif

	// ------------- Bottoni dx
	ApreBottone(area_subcmd,
		40,15,200,20,"Single Candidate",SingleCandidate);
	ApreBottone(area_subcmd,
		40,40,200,20,"Intersection Removal",IntersectionRemoval);
	ApreBottone(area_subcmd,
		40,65,200,20,"Naked",Naked);
	ApreBottone(area_subcmd,
		40,90,200,20,"Hidden",Hidden);
	ApreBottone(area_subcmd,
		40,115,200,20,"Fish",XWing);
	ApreBottone(area_subcmd,
		40,140,200,20,"XYWing",XYWing);
	ApreBottone(area_subcmd,
		40,300,200,20,"Cmd Future ???",NULL);

	// ------------- Bottoni arrows
	ApreBottone(area_cmd,5,295,20,20,"<<",MoveSavedTop);
	ApreBottone(area_cmd,30,295,40,20,"<",MoveSavedDn);

	c=ApreArea (area_cmd,80,295,125,20,GetColor(WINBG),GetColor(WINFG),0);
	strcpy (STEP,"0/0");
	CmdStep=Print (c,3,0,"Step ");
	CmdStep=Print (c,8,0,STEP);

	ApreBottone(area_cmd,215,295,40,20,">",MoveSavedUp);
	ApreBottone(area_cmd,260,295,20,20,">>",MoveSavedBottom);
	
	SudokuNuovo();

	xScrollBar (area_subcmd,1);

	Menu(mio);

	Eventi (mio);	

	ChiudeDisplay();

	return (0);

}

